import unittest

from pyson.ObjectMapper import ObjectMapper

from geniusweb.actions.PartyId import PartyId
from geniusweb.inform.Agreements import Agreements
from geniusweb.inform.Finished import Finished
from geniusweb.inform.Inform import Inform
from geniusweb.issuevalue.Bid import Bid


class FinishedTest(unittest.TestCase):
    id1 = PartyId("party1")
    id2 = PartyId("party2")
    
    bid1 = Bid({})
    agrees1  = Agreements({id1: bid1, id2:bid1 })
    finished1  = Finished(agrees1)
    
    finished1json:dict={'Finished':{'agreements':{'party1':{'issuevalues':{}},'party2':{'issuevalues':{}}}}}
    
    def testNull(self) :
        Agreements();

    def testNone(self) :
        self.assertRaises(ValueError, lambda:Finished(None))

    def testSerialize(self):
        
        actor=PartyId("myid")
        # HACK currently bid requires all values same type
        
        pyson=ObjectMapper()
        print(str(pyson.toJson(self.finished1)))
        self.assertEqual(self.finished1json, pyson.toJson(self.finished1))
        
    def testDeserialize(self):
        pyson=ObjectMapper()

        self.assertEqual(self.finished1, pyson.parse(self.finished1json, Inform))
        